﻿using Infragistics.Win.UltraWinGrid;
using System.Windows.Forms;
/// <summary>
/// http://www.infragistics.com/community/forums/t/108726.aspx
/// Child bands cannot be made to indent to a specific column of the parent.
/// Empty "dummy" columns can be created in the child band in InitializeLayout
/// in order to indent the band columns to a certain column of the parent.
/// </summary>
namespace ultraGridBoilerPlate
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            ultraGrid1.InitializeLayout += UltraGrid1_UseDummyColumns;
            ultraGrid1.DataSource = ultraDataSource1;
        }

        private void UltraGrid1_UseDummyColumns(object sender, InitializeLayoutEventArgs e)
        {
            var layout = e.Layout;

            foreach (UltraGridBand band in layout.Bands)
            {
                band.AddDummyColumns(band.Index);
            }
        }
    }

    static class ExtensionMethods
    {
        internal static void AddDummyColumns(this UltraGridBand band, int columns)
        {
            for (int i = 0; i < columns; i++)
            {
                UltraGridColumn dummyColumn = band.Columns.Add();
                dummyColumn.Header.VisiblePosition = i;
                dummyColumn.CellActivation = Activation.Disabled;
                dummyColumn.Header.Enabled = false;
            }
        }
    }
}
